function [x,i] = max(x,y)
%PDERIV/MAX	Maximum
% This is a "winner take all" implementation, in which the result is identical to the first, largest value.
% Note that the derivative of max has a discontinuity in this case, and so this implementation is not fully correct.
% The dimension argument is not yet supported.

if nargin == 2
    i = y > x;
    if isobject(x)
        if isscalar(y)
            x = pderiv_setsub(x, {i}, y);
        elseif isscalar(x)
            if isobject(y)
                x = pderiv_setsub(y, {~i}, x(~i));
            else
                x = repmat(x, size(x));
                x = pderiv_setsub(x, {i}, y(i));
            end
        else
            x = pderiv_setsub(x, {i}, y(i));
        end
    else
        if isscalar(x)
            x = pderiv_setsub(y, {~i}, x);
        elseif isscalar(y)
            y = repmat(y, size(x));
            x = pderiv_setsub(y, {~i}, x(~i));
        else
            x = pderiv_setsub(y, {~i}, x(~i));
        end
    end
else
    [l s1 s] = sizeshift(size(x.d));
    [m,i] = max(x.v,[],1);
    n = numel(i);
    x = pderiv_subs(x, {sub2ind([s1 n], i(:), (1:n)')});
    x = reshape(x, [1 s]);
end
