function d = pderiv(a, varargin)
%PDERIV	Derivative representation constructor.
%   D = PDERIV_MAKE(C) is the constant C.
%   D = PDERIV_MAKE(V, D1P, D2P, ...) is the value V with partial derivatives d^nV/(dPi dPj ...) = shiftdim(DP(i,j,...,:),n) stacked for all parameters.

if nargin == 0
    a = [];
    ad = [];
elseif isa(a, 'pderiv')
    d = a;
    return
%elseif isstruct(a)
%    assert(isscalar(a));
%    d = class(a, 'pderiv');
%    return
elseif nargin == 1
    %assert(isa(a, 'double'));
    d = a;
    return
%elseif samesize(varargin{1}, a)
%   D = PDERIV_MAKE(V, DP1, DP2, ...) is the value V with partial derivatives dV/dPi = DPn for each parameter.
    % per-parameter first derivatives
%    ad = cellfun(@(x)shiftdim(x,-1), varargin, 'UniformOutput', false);
%    ad = vertcat(ad{:});
elseif nargin == 2
    % optimization
    ad = varargin{1};
else
    % all nth derivatives in varargin{n}
    ad = pderiv(varargin{:});
end
%assert(isa(a, 'double'));
%sa = size(a); sd = size(ad);
%if length(sd) == 2; sd = [sd 1]; end
%assert(isequal(sa, sd(2:end)), 'Mismatching pderiv arguments');
d.v = a; d.d = ad;
d = class(d, 'pderiv');
