function z = power(x,y)
%PDERIV/POWER	Exponentiate
%   Z = X .^ Y computes the derivative representation of X^Y for each element

if ~isobject(y)
    x0 = pderiv_d0(x);
    x.v = x.v .^ y;
    x.d = map01(@times, y .* x0 .^ (y - 1), x.d);
    x.d = pderiv_setsub(x.d, {':' x0 == 0 & y == 0}, 0);
    z = x;
else
    %z = exp(log(x) .* y);
    [x y] = pderiv_all(x,y);
    x0 = pderiv_d0(x);
    y0 = pderiv_d0(y);
    z = pderiv(x.v .^ y.v, ...
            map01(@times, x0 .^ y0, map01(@times, y0 ./ x0, x.d) + map01(@times, log(x0), y.d)));
end
