function d = map01(f, d0, d1)
% optimization of pdmap01

if isscalar(d0)
    d = f(d0, d1);
elseif isobject(d0) || isobject(d1)
    s = size(d1);
    if length(s) == 2 && s(2) == 1
        d1 = repmat(d1, [1 size(d0)]);
    end
    d0 = repmat(shiftdim(d0, -1), s(1), 1);
    d = f(d0, d1);
else
    d = bsxfun(f, shiftdim(d0, -1), d1);
end
