function d = subsref(d, ix)
%PDERIV/SUBSREF
%   X.d0, X.v are the values
%   X.d1, X.d are the derivatives with the parameters in the first dimension
%   X.d1(N), X.d(N) are the derivatives with respect to parameter N

i = 1;
if i <= length(ix) && strcmp(ix(i).type, '()')
    d = pderiv_subs(d, ix(i).subs);
    i = i+1;
end

if i <= length(ix) && strcmp(ix(i).type, '.')

    if ix(i).subs(1) ~= 'd'
        error('Unknown pderiv field');
    end

    dn = -1;
    if length(ix(i).subs) > 1
        dn = str2double(ix(i).subs(2:end));
    end
    i = i+1;

    di = [];
    if i <= length(ix) && strcmp(ix(i).type, '()')
        di = ix(i).subs;
        i = i+1;
    end

    if dn == -1 && ~isempty(di) && isscalar(di{1})
        dn = di{1};
        di = {di{2:end}};
    end

    assert(~isnan(dn) && dn >= 0 && length(di) <= dn, 'Invalid pderiv field');

    for id=1:dn
        if ~isobject(d)
            error('access to unmaintained derivative');
        end
        sz = size(d);
        d = d.d;
        if id <= length(di) && ~strcmp(di{1}, ':')
            if ~isscalar(di{id})
                sz = [length(di{id}) sz];
            end
            d = reshape(d(di{id},:), sz);
        end   
    end
    d = pderiv_v(d);
end

assert(i > length(ix), 'Unknown pderiv subscript');
