function d = pderiv_var(p, n)
%PDERIV_VAR	Derivative representation of a parameter variable.
%   D = PDERIV_VAR(P, N) returns the derivative representation of the variable P(N).  Index 0 is implicitly the 0 value.

if nargin == 1
    n = ':';
end

l = numel(p);
if strcmp(n, ':')
    n = reshape(1:l, size(p));
end

pv = [ 0 ; p(:) ];
po = [ zeros(l, 1) eye(l) ];

s = size(n);
p = reshape(pv(n+1), s);
pd = reshape(po(:,n+1), [l s]);

d = pderiv(p, pd);
